Index: /collectparties.sh
===================================================================
--- /collectparties.sh	(revision 25)
+++ /collectparties.sh	(revision 26)
@@ -7,5 +7,5 @@
 rm -rf collectedparties
 mkdir collectedparties
-VERSION=1.5.4
+VERSION=1.5.5
 
 cp "exampleparties/anac2019/agentgg/target/agentgg-${VERSION}-jar-with-dependencies.jar" collectedparties
Index: /events/src/main/java/geniusweb/actions/Votes.java
===================================================================
--- /events/src/main/java/geniusweb/actions/Votes.java	(revision 25)
+++ /events/src/main/java/geniusweb/actions/Votes.java	(revision 26)
@@ -2,8 +2,8 @@
 
 import java.util.Collections;
-import java.util.List;
 import java.util.Map;
 import java.util.Map.Entry;
 import java.util.Optional;
+import java.util.Set;
 import java.util.stream.Collectors;
 
@@ -18,5 +18,5 @@
  */
 public class Votes extends AbstractAction {
-	private final List<Vote> votes;
+	private final Set<Vote> votes;
 
 	/**
@@ -24,10 +24,10 @@
 	 * @param id    party id
 	 * @param votes the {@link Vote}s that the party can agree on, if the
-	 *              condition of the Vote holds. There can be at most 1
-	 *              {@link Vote} for each bid.
+	 *              condition of the Vote holds. Every {@link Vote#getActor()}
+	 *              should equal the id
 	 */
 	@JsonCreator
 	public Votes(@JsonProperty("actor") PartyId id,
-			@JsonProperty("votes") List<Vote> votes) {
+			@JsonProperty("votes") Set<Vote> votes) {
 		super(id);
 		this.votes = votes;
@@ -40,4 +40,5 @@
 			}
 		}
+		// check for duplicate Vote's, possibly with different powers
 		Map<Bid, Long> counts = votes.stream().map(vote -> vote.getBid())
 				.collect(Collectors.groupingBy(bid -> bid,
@@ -86,6 +87,6 @@
 	}
 
-	public List<Vote> getVotes() {
-		return Collections.unmodifiableList(votes);
+	public Set<Vote> getVotes() {
+		return Collections.unmodifiableSet(votes);
 	}
 
Index: /events/src/main/java/geniusweb/inform/Agreements.java
===================================================================
--- /events/src/main/java/geniusweb/inform/Agreements.java	(revision 25)
+++ /events/src/main/java/geniusweb/inform/Agreements.java	(revision 26)
@@ -5,4 +5,5 @@
 import java.util.Map;
 import java.util.Set;
+import java.util.stream.Collectors;
 
 import com.fasterxml.jackson.annotation.JsonAutoDetect;
@@ -29,6 +30,15 @@
 
 	@JsonCreator
-	private Agreements(Map<PartyId, Bid> agrees) {
+	protected Agreements(Map<PartyId, Bid> agrees) {
 		this.agreements = agrees;
+	}
+
+	/**
+	 * @param bid     a bid that all parties agreed on
+	 * @param parties the {@link PartyId}s of the agreeing parties
+	 */
+	public Agreements(Bid bid, Set<PartyId> parties) {
+		this(parties.stream()
+				.collect(Collectors.toMap(pid -> pid, pid -> bid)));
 	}
 
@@ -48,25 +58,4 @@
 		}
 		return new Agreements(newagrees);
-	}
-
-	/**
-	 * @param bid     a {@link Bid} to be added
-	 * @param parties {@link Set} of the {@link PartyId}s that accepted the bid
-	 * @return new Agreements, with the new bid/parties added.
-	 */
-	public Agreements with(Bid bid, Set<PartyId> parties) {
-		if (parties.size() < 2) {
-			throw new IllegalArgumentException(
-					"Agreement must contain at least 2 parties");
-		}
-		Map<PartyId, Bid> newagreements = new HashMap<>(agreements);
-		for (PartyId party : parties) {
-			if (agreements.containsKey(party)) {
-				throw new IllegalArgumentException(
-						"A party can agree only on 1 bid");
-			}
-			newagreements.put(party, bid);
-		}
-		return new Agreements(newagreements);
 	}
 
Index: /events/src/main/java/geniusweb/inform/Voting.java
===================================================================
--- /events/src/main/java/geniusweb/inform/Voting.java	(revision 25)
+++ /events/src/main/java/geniusweb/inform/Voting.java	(revision 26)
@@ -8,6 +8,6 @@
 import com.fasterxml.jackson.annotation.JsonProperty;
 
+import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
-import geniusweb.issuevalue.Bid;
 
 /**
@@ -16,11 +16,11 @@
 public class Voting implements Inform {
 
-	private final List<Bid> bids;
+	private final List<Offer> offers;
 	private final Map<PartyId, Integer> powers;
 
 	@JsonCreator
-	public Voting(@JsonProperty("bids") List<Bid> bids,
+	public Voting(@JsonProperty("offers") List<Offer> offers,
 			@JsonProperty("powers") Map<PartyId, Integer> powers) {
-		this.bids = bids;
+		this.offers = offers;
 		this.powers = powers;
 	}
@@ -29,6 +29,6 @@
 	 * @return list of bids to be voted on
 	 */
-	public List<Bid> getBids() {
-		return Collections.unmodifiableList(bids);
+	public List<Offer> getBids() {
+		return Collections.unmodifiableList(offers);
 	}
 
@@ -47,5 +47,5 @@
 		final int prime = 31;
 		int result = 1;
-		result = prime * result + ((bids == null) ? 0 : bids.hashCode());
+		result = prime * result + ((offers == null) ? 0 : offers.hashCode());
 		result = prime * result + ((powers == null) ? 0 : powers.hashCode());
 		return result;
@@ -61,8 +61,8 @@
 			return false;
 		Voting other = (Voting) obj;
-		if (bids == null) {
-			if (other.bids != null)
+		if (offers == null) {
+			if (other.offers != null)
 				return false;
-		} else if (!bids.equals(other.bids))
+		} else if (!offers.equals(other.offers))
 			return false;
 		if (powers == null) {
@@ -76,5 +76,5 @@
 	@Override
 	public String toString() {
-		return "Voting[" + bids + "," + powers + "]";
+		return "Voting[" + offers + "," + powers + "]";
 	}
 
Index: /events/src/test/java/geniusweb/actions/AcceptTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/AcceptTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/AcceptTest.java	(revision 26)
@@ -0,0 +1,91 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class AcceptTest extends GeneralTests<Accept> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final PartyId id2 = new PartyId("party2");
+	private final static Map<String, Value> issuevalues = new HashMap<String, Value>();
+	private final static Map<String, Value> issuevaluesb = new HashMap<String, Value>();
+	private static Bid bid;
+	private static Bid bidb;
+	private final static String ISSUE1 = "issue1";
+	private final static Value VALUE1 = new DiscreteValue("value1");
+	private final static String ISSUE2 = "issue2";
+	private final static Value VALUE2 = new NumberValue("10");
+	// issue 2 is NUMBER and thus serializes with leading '='
+	private final String acceptstring = "{\"accept\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}}}}";
+
+	private static Accept accept, accept1, accept2, acceptb;
+
+	static {
+		issuevalues.put(ISSUE1, VALUE1);
+		issuevalues.put(ISSUE2, VALUE2);
+		bid = new Bid(issuevalues);
+		accept = new Accept(id, bid);
+		accept1 = new Accept(id, bid);
+
+		accept2 = new Accept(id2, bid);
+
+		// values swapped, so different issuevalues.
+		issuevaluesb.put(ISSUE1, VALUE2);
+		issuevaluesb.put(ISSUE2, VALUE2);
+		bidb = new Bid(issuevaluesb);
+		acceptb = new Accept(id, bidb);
+
+	}
+
+	@Override
+	public List<List<Accept>> getGeneralTestData() {
+		List<List<Accept>> list = new LinkedList<>();
+		list.add(Arrays.asList(accept, accept1));
+		list.add(Arrays.asList(accept2));
+		list.add(Arrays.asList(acceptb));
+		return list;
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Accept.*" + id + ".*]", "Accept.*" + id2 + ".*]",
+				"Accept.*" + id + ".*]");
+	}
+
+	@Before
+	public void before() {
+
+	}
+
+	@Test
+	public void serializeAcceptTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(accept));
+		assertEquals(acceptstring, jackson.writeValueAsString(accept));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Action act = jackson.readValue(acceptstring, Action.class);
+		assertEquals(accept, act);
+	}
+
+}
Index: /events/src/test/java/geniusweb/actions/ComparisonTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/ComparisonTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/ComparisonTest.java	(revision 26)
@@ -0,0 +1,97 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class ComparisonTest extends GeneralTests<Comparison> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final PartyId id2 = new PartyId("party2");
+	private final static Map<String, Value> issuevalues = new HashMap<String, Value>();
+	private final static Map<String, Value> issuevaluesb = new HashMap<String, Value>();
+	private static Bid bid;
+	private static Bid bidb;
+	private final static String ISSUE1 = "issue1";
+	private final static Value VALUE1 = new DiscreteValue("value1");
+	private final static String ISSUE2 = "issue2";
+	private final static Value VALUE2 = new NumberValue("10");
+	// issue 2 is NUMBER and thus serializes with leading '='
+	private final String acceptstring = "{\"Comparison\":{\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}},\"better\":[],\"worse\":[],\"actor\":\"party1\"}}";
+
+	private static Comparison accept, accept1, accept2, acceptb, acceptc,
+			acceptd;
+
+	@Before
+	public void before() {
+		issuevalues.put(ISSUE1, VALUE1);
+		issuevalues.put(ISSUE2, VALUE2);
+		bid = new Bid(issuevalues);
+		List<Bid> better = Collections.EMPTY_LIST;
+		List<Bid> worse = Collections.EMPTY_LIST;
+		accept = new Comparison(id, bid, better, worse);
+		accept1 = new Comparison(id, bid, better, worse);
+
+		accept2 = new Comparison(id2, bid, better, worse);
+
+		// values swapped, so different issuevalues.
+		issuevaluesb.put(ISSUE1, VALUE2);
+		issuevaluesb.put(ISSUE2, VALUE2);
+		bidb = new Bid(issuevaluesb);
+		acceptb = new Comparison(id, bidb, better, worse);
+
+		List<Bid> better1 = Arrays.asList(bid);
+		List<Bid> worse1 = Arrays.asList(bidb);
+		acceptc = new Comparison(id, bidb, better1, worse);
+		acceptd = new Comparison(id, bidb, better, worse1);
+
+	}
+
+	@Override
+	public List<List<Comparison>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(accept, accept1),
+				Arrays.asList(accept2), Arrays.asList(acceptb),
+				Arrays.asList(acceptc), Arrays.asList(acceptd));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"Comparison.*Bid.*issue2=10.*issue1=\"value1\".*better=\\[\\].*worse=\\[\\].*",
+				"Comparison.*party2.*Bid.*issue2=10.*issue1=\"value1\".*better=\\[\\].*worse=\\[\\].*",
+				"Comparison.*party1.*Bid.*issue2=10.*issue1=10.*better=\\[\\].*worse=\\[\\].*",
+				"Comparison.*party1.*Bid.*issue2=10.*issue1=10.*better=\\[Bid.*issue2=10.*issue1=\"value1\".*\\].*worse=\\[\\].*",
+				"Comparison.*party1.*Bid.*issue2=10.*issue1=10.*better=\\[\\].*worse=\\[Bid.*issue2=10.*issue1=10.*\\].*");
+	}
+
+	@Test
+	public void serializeAcceptTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(accept));
+		assertEquals(acceptstring, jackson.writeValueAsString(accept));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Action act = jackson.readValue(acceptstring, Action.class);
+		assertEquals(accept, act);
+	}
+
+}
Index: /events/src/test/java/geniusweb/actions/ElicitComparisonTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/ElicitComparisonTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/ElicitComparisonTest.java	(revision 26)
@@ -0,0 +1,89 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class ElicitComparisonTest extends GeneralTests<ElicitComparison> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final PartyId id2 = new PartyId("party2");
+	private final static Map<String, Value> issuevalues = new HashMap<String, Value>();
+	private final static Map<String, Value> issuevaluesb = new HashMap<String, Value>();
+	private static Bid bid;
+	private static Bid bidb;
+	private final static String ISSUE1 = "issue1";
+	private final static Value VALUE1 = new DiscreteValue("value1");
+	private final static String ISSUE2 = "issue2";
+	private final static Value VALUE2 = new NumberValue("10");
+	// issue 2 is NUMBER and thus serializes with leading '='
+	private final String acceptstring = "{\"ElicitComparison\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}},\"options\":[{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}}]}}";
+
+	private static ElicitComparison accept1, accept1a, accept2, accept3,
+			accept4;
+
+	@Before
+	public void before() {
+		issuevalues.put(ISSUE1, VALUE1);
+		issuevalues.put(ISSUE2, VALUE2);
+
+		issuevaluesb.put(ISSUE1, VALUE2);
+		bid = new Bid(issuevalues);
+		bidb = new Bid(issuevaluesb);
+
+		List<Bid> opts = Arrays.asList(bid);
+		List<Bid> opts2 = Arrays.asList(bidb);
+
+		accept1 = new ElicitComparison(id, bid, opts);
+		accept1a = new ElicitComparison(id, bid, opts);
+		accept2 = new ElicitComparison(id2, bid, opts);
+		accept3 = new ElicitComparison(id, bidb, opts);
+		accept4 = new ElicitComparison(id, bid, opts2);
+	}
+
+	@Override
+	public List<List<ElicitComparison>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(accept1, accept1a),
+				Arrays.asList(accept2), Arrays.asList(accept3),
+				Arrays.asList(accept4));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"ElicitComparison.*party1.*Bid.*10.*value1.*\\[.*Bid.*10.*value1.*\\].*",
+				"ElicitComparison.*party2.*Bid.*10.*value1.*\\[.*Bid.*10.*value1.*\\].*",
+				"ElicitComparison.*party1.*Bid.*10.*\\[.*Bid.*10.*value1.*\\].*",
+				"ElicitComparison.*party1.*Bid.*10.*value1.*\\[.*Bid.*10.*\\].*");
+	}
+
+	@Test
+	public void serializeAcceptTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(accept1));
+		assertEquals(acceptstring, jackson.writeValueAsString(accept1));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Action act = jackson.readValue(acceptstring, Action.class);
+		assertEquals(accept1, act);
+	}
+
+}
Index: /events/src/test/java/geniusweb/actions/EndNegoTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/EndNegoTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/EndNegoTest.java	(revision 26)
@@ -0,0 +1,52 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import tudelft.utilities.junit.GeneralTests;
+
+public class EndNegoTest extends GeneralTests<EndNegotiation> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private final PartyId id = new PartyId("party1");
+	private final PartyId idb = new PartyId("party2");
+
+	private final EndNegotiation endnego = new EndNegotiation(id);
+	private final EndNegotiation endnego1 = new EndNegotiation(id);
+	private final EndNegotiation endnegob = new EndNegotiation(idb);
+
+	private final String endnegostring = "{\"endnegotiation\":{\"actor\":\"party1\"}}";
+
+	@Override
+	public List<List<EndNegotiation>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(endnego, endnego1),
+				Arrays.asList(endnegob));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("EndNegotiation\\[.*" + id + ".*\\]",
+				"EndNegotiation\\[.*" + idb + ".*\\]");
+	}
+
+	@Test
+	public void serializeEndNegoTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(endnego));
+		assertEquals(endnegostring, jackson.writeValueAsString(endnego));
+	}
+
+	@Test
+	public void deserializeEndNegoTest() throws IOException {
+		Action act = jackson.readValue(endnegostring, Action.class);
+		assertEquals(endnego, act);
+	}
+
+}
Index: /events/src/test/java/geniusweb/actions/OfferTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/OfferTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/OfferTest.java	(revision 26)
@@ -0,0 +1,79 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class OfferTest extends GeneralTests<Offer> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final Map<String, Value> issuevalues = new HashMap<String, Value>();
+	private static final Map<String, Value> issuevaluesb = new HashMap<String, Value>();
+	private static Bid bid;
+	private static Bid bidb;
+	private static final String ISSUE1 = "issue1";
+	private static final Value VALUE1 = new DiscreteValue("value1");
+	private static final String ISSUE2 = "issue2";
+	private static final Value VALUE2 = new NumberValue("10");
+	private static final String acceptstring = "{\"offer\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}}}}";
+
+	private static Offer offer;
+	private static Offer offer1;
+	private static Offer offerb;
+
+	static {
+		issuevalues.put(ISSUE1, VALUE1);
+		issuevalues.put(ISSUE2, VALUE2);
+		bid = new Bid(issuevalues);
+		offer = new Offer(id, bid);
+		offer1 = new Offer(id, bid);
+
+		// values swapped, so different issuevalues.
+		issuevaluesb.put(ISSUE1, VALUE2);
+		issuevaluesb.put(ISSUE2, VALUE2);
+		bidb = new Bid(issuevaluesb);
+		offerb = new Offer(id, bidb);
+
+	}
+
+	@Override
+	public List<List<Offer>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(offer, offer1),
+				Arrays.asList(offerb));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Offer\\[.*" + id + ".*Bid.*\\]",
+				"Offer\\[.*" + id + ".*Bid.*\\]");
+	}
+
+	@Test
+	public void serializeAcceptTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(offer));
+		assertEquals(acceptstring, jackson.writeValueAsString(offer));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Action act = jackson.readValue(acceptstring, Action.class);
+		assertEquals(offer, act);
+	}
+
+}
Index: /events/src/test/java/geniusweb/actions/PartyIdTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/PartyIdTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/PartyIdTest.java	(revision 26)
@@ -0,0 +1,74 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Test;
+
+import tudelft.utilities.junit.GeneralTests;
+
+public class PartyIdTest extends GeneralTests<PartyId> {
+	private final PartyId id = new PartyId("party1");
+	private final PartyId id1 = new PartyId("party1");
+	private final PartyId idb = new PartyId("party2");
+
+	@Override
+	public List<List<PartyId>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(id, id1), Arrays.asList(idb));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("party1", "party2");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testRestrictions() {
+		new PartyId("");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testRestrictions2() {
+		new PartyId("@2");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testRestrictions3() {
+		new PartyId("_12");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testRestrictions4() {
+		new PartyId("12A");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testRestrictions5() {
+		new PartyId(" fds ");
+	}
+
+	@Test
+	public void testGetName() {
+		assertEquals("party1", id.getName());
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void testRestrictions6() {
+		new PartyId("A_1_23_ok");
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void testRestrictions7() {
+		new PartyId("a_1_23_ok");
+	}
+
+}
Index: /events/src/test/java/geniusweb/actions/PartyIdTest1.java
===================================================================
--- /events/src/test/java/geniusweb/actions/PartyIdTest1.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/PartyIdTest1.java	(revision 26)
@@ -0,0 +1,74 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import tudelft.utilities.junit.GeneralTests;
+
+public class PartyIdTest1 extends GeneralTests<PartyId> {
+
+	private PartyId party1, party1a, party2, party3;
+	private String asJson = "\"party1\"";
+
+	@Before
+	public void before() throws URISyntaxException {
+		party1 = new PartyId("party1");
+		party1a = new PartyId("party1");
+		party2 = new PartyId("party2");
+		party3 = new PartyId("party3");
+	}
+
+	@Override
+	public List<List<PartyId>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(party1, party1a),
+				Arrays.asList(party2), Arrays.asList(party3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("party1", "party2", "party3");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void smokeTest() throws URISyntaxException {
+		new PartyId("*Csh789&@#^!^@^&");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void nullTest() throws URISyntaxException {
+		new PartyId(null);
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(party1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		PartyId p = jackson.readValue(asJson, PartyId.class);
+		System.out.println(p);
+		assertEquals(party1, p);
+	}
+
+}
Index: /events/src/test/java/geniusweb/actions/VoteTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/VoteTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/actions/VoteTest.java	(revision 26)
@@ -0,0 +1,94 @@
+package geniusweb.actions;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class VoteTest extends GeneralTests<Vote> {
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static final PartyId id = new PartyId("party1");
+	private static final PartyId id2 = new PartyId("party2");
+	private final static Map<String, Value> issuevalues = new HashMap<String, Value>();
+	private final static Map<String, Value> issuevaluesb = new HashMap<String, Value>();
+	private static Bid bid;
+	private static Bid bidb;
+	private final static String ISSUE1 = "issue1";
+	private final static Value VALUE1 = new DiscreteValue("value1");
+	private final static String ISSUE2 = "issue2";
+	private final static Value VALUE2 = new NumberValue("10");
+	// issue 2 is NUMBER and thus serializes with leading '='
+	private final String votestring = "{\"vote\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}},\"minPower\":1,\"maxPower\":2}}";
+
+	private static Vote vote1, vote1a, vote2, vote3, vote4, vote5;
+
+	static {
+		issuevalues.put(ISSUE1, VALUE1);
+		issuevalues.put(ISSUE2, VALUE2);
+		bid = new Bid(issuevalues);
+		vote1 = new Vote(id, bid, 1, 2);
+		vote1a = new Vote(id, bid, 1, 2);
+
+		vote2 = new Vote(id2, bid, 1, 2);
+
+		// values swapped, so different issuevalues.
+		issuevaluesb.put(ISSUE1, VALUE2);
+		issuevaluesb.put(ISSUE2, VALUE2);
+		bidb = new Bid(issuevaluesb);
+		vote3 = new Vote(id, bidb, 1, 2);
+
+		vote4 = new Vote(id, bid, 2, 2);
+		vote5 = new Vote(id, bid, 1, 3);
+
+	}
+
+	@Override
+	public List<List<Vote>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(vote1, vote1a), Arrays.asList(vote2),
+				Arrays.asList(vote3), Arrays.asList(vote4),
+				Arrays.asList(vote5));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Vote.*party1.*issue2=10.*issue1=.value1.*1.*2.*",
+				"Vote.*party2.*issue2=10.*issue1=.value1.*1.*2.*",
+				"Vote.*party1.*issue2=10.*issue1=10.*1.*2.*",
+				"Vote.*party1.*issue2=10.*issue1=.value1.*2.*2.*",
+				"Vote.*party1.*issue2=10.*issue1=.value1.*1.*3.*");
+	}
+
+	@Before
+	public void before() {
+
+	}
+
+	@Test
+	public void serializeTest() throws JsonProcessingException {
+		System.out.println(jackson.writeValueAsString(vote1));
+		assertEquals(votestring, jackson.writeValueAsString(vote1));
+	}
+
+	@Test
+	public void deserializeAcceptTest() throws IOException {
+		Action act = jackson.readValue(votestring, Action.class);
+		assertEquals(vote1, act);
+	}
+
+}
